/* =================================================================================
 *  mainAlberi.c
 * =================================================================================
 *  Programma di test per esercizi su alberi binari
 *  Authors:     Emanuela Fachini  (fachini@di.uniroma1.it )
 *               Irene Finocchi    (finocchi@di.uniroma1.it)
 *               Chiara Petrioli   (petrioli@di.uniroma1.it)
 *  Last change: 14 Aprile 2005
 *  Changed by:  Irene Finocchi
*/

#include "alberi.h"

int main(void) {

	TreePtr TT;
	TreePtr UU;
	int x, y;
	TREENODE *nodePtr;

    printf("Costruzione di un albero binario inserito da input.\n\n") ;
    printf("Gli interi contenuti nei nodi vanno inseriti in preordine.\n") ;
    printf("L'input consiste di coppie <i,j> dove\n") ;
    printf("   i rappresenta il valore intero del nodo\n") ;
    printf("   j vale: 0 se il nodo non ha figli, -1 se ha solo figlio sinistro\n") ;
    printf("           1 se ha solo figlio destro, 2 se ha entrambi i figli\n\n") ;

    printf("Inserisci ora la sequenza di coppie i j, terminando con un ritorno a capo\n") ;
    printf("(ad esempio 10 2 8 -1 3 0 4 2 2 0 5 2 6 0 7 0):\n") ;

	TT=creaalbero();

	printf("\nVisita inorder dell'albero:\n");
	stampaAlberoInorder(TT);

	printf("\n\n");

	printf("Stampa indentata dell'albero \n\n");
	stampaIndentata(TT,0);

	printf("\n");

	printf("\nVerifico se l'albero e' pieno:\n");

	/* Verifica se l'albero e' pieno */
    /* Esempio di albero pieno: 2 2 3 2 5 0 1 0 8 2 7 0 6 0 */
    /* Esempio interessante di albero non pieno: 10 2 8 2 3 0 12 0 4 2 2 0 5 1 7 0 */
	if (AlberoPieno(TT)==1) printf("L'albero e' pieno.\n\n");
	else printf("L'albero non e' pieno.\n\n");
	
	printf("Eseguo l'implementazione piu' efficiente.\n");

	if (AlberoPienoVeloce(TT,&nodePtr,&x)==1) printf("L'albero e' pieno.\n\n");
	else {
	    printf("L'albero non e' pieno.\n");
	    printf("Il primo nodo sbilanciato ha valore %d e altezza %d.\n\n",nodePtr->elem,x);
	}
	
    /* Prefisso */
    /* Esempio di prefisso: 
    T = 10 2 8 -1 3 0 4 2 2 0 5 2 6 0 7 0
    U = 10 2 4 -1 5 0 8 1 3 0 */

	printf("\nPrefisso.\n");

    printf("Inserisci il sottoalbero: \n") ;
    UU=creaalbero();

	printf("Stampa indentata dell'albero U \n\n");
	stampaIndentata(UU,0);

	printf("\n");

	if (prefTree(TT,UU)==1) printf("L'albero U e' un prefisso di T.\n\n");
	else printf("L'albero U non e' un prefisso di T.\n\n");
    
    /* Verifica se esiste un cammino da un nodo con valore x a un nodo con valore y */
	printf("\nVerifico se esiste un cammino da x a y:\n");

    while (1) {
        printf("Inserisci x e y (-1 per uscire): ");
        scanf("%d",&x);
        if (x==-1) break;
        scanf("%d",&y);
    
        /* path assume che non ci siano ripetizioni di nodi (puo' non essere corretta nel
           caso di ripetizioni), path2 accetta anche alberi contenenti ripetizioni        */
        /* Esempio interessante con ripetizioni: 1 2 2 2 5 0 12 0 3 2 2 2 7 0 4 0 1 0     */ 
        if (path2(TT,x,y)==1)                             /*     if (path(TT,x,y)==1)     */
             printf("Esiste un cammino da un nodo con valore %d a un nodo con valore %d\n",x,y);
        else printf("Non esiste un cammino da un nodo con valore %d a un nodo con valore %d\n",x,y);
    }
    
	printf("\nSayonara!\n");

	return 1;
}

